
DATA_SECTION
   init_int n;                        // number of distances
   init_number width;
   init_vector xs(1,n);               // distances
PARAMETER_SECTION
   init_number beta;                  // beta parameter for log-sigma;
   init_bounded_number sigeps(0.000001,5);
                                      // sigma for random effect;
   random_effects_vector u(1,n);      // random effect for scale
   objective_function_value f;        // negative log-likelihood
GLOBALS_SECTION
  #include <admodel.h>
  #include <df1b2fun.h>
  #include <adrndeff.h>

  //df1b2_pre_parameters::adromb(df1b2variable (df1b2_parameters::*)(const df1b2variable&), int, data_number&, int);




PROCEDURE_SECTION
   int j;
// loop over each observation computing sum of log-likelihood values
// integral is sqrt(pi/2)*sigma; I dropped constant
   f=0;
   for (j=1;j<=n;j++)
   {
      ll_j(j,beta,sigeps,u(j));
   }

SEPARABLE_FUNCTION void ll_j(const int j, const dvariable& beta,const dvariable& sigeps,const dvariable& u)
   dvariable eps=u*sigeps;
   int k;
   dvariable mu;
   dvariable sigma=exp(beta+eps);
   adromb(&model_parameters::fct,0,width,mu,&sigma,8);
   f -= -0.5*square(u);
   f -= -log(mu) - 0.5*square(xs(j)/sigma);

FUNCTION dvariable fct(const dvariable& x,void * ps)
// x is integration variable
// ifct is index for function read from data
   dvariable tmp;
   dvariable sigma=* (dvariable *)(ps);
   tmp=mfexp(-.5*x*x/square(sigma));
   return tmp;
